/*
Operservice 2
(C) Michael Meier 2000-2001 - released under GPL
-----------------------------------------------------------------------------
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
------------------------------------------------------------------------------

Compiling: edit the Makefile so that the path to mysql-libs and includes is
           correct. Then compile with:
           make
Start with ./Operservice configfilename

ToDo:
- better mirkforce-checker: check for lots of clients with same realname
- add/delete chans
- userlist-functions
- more trustfunctions
*/
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "mysql_version.h"
#include "mysql.h"
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "globals.h"

char dummy[20];
serverdata *sls;
userdata * uls[SIZEOFUL]; /* Userlist */
channel * cls[SIZEOFCL];  /* Channellist */
array nls[SIZEOFNL];      /* Nicklist  - ! NOT YET USED !*/
autheduser *als;  /* List of authed users */
flags chanflags[]={
  {'p',cm_p},
  {'s',cm_s},
  {'m',cm_m},
  {'n',cm_n},
  {'t',cm_t},
  {'i',cm_i},
  {'l',cm_l},
  {'k',cm_k}
};
int numcf; /* Number of Chanflags */
flags userflags[]={
  {'o',um_o},
  {'v',um_v}
};
int numuf; /* Number of Userflags (Flags of a user on a channel) */
FILE *sockin, *sockout;
char lastline[520]; /* Last line received from the ircserver */
char tokens[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]";
unsigned int reversetok[] = {
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 0,  0,
  0,  0,  0,  0,  0,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  10, 11, 12, 13, 14,
  15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 62, 0,  63, 0,  0,  0,  26, 27, 28,
  29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,
  49, 50, 51, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
};
char crytok[]="ABCDEFGHIJKLMNOPQ/RSTUVWXYZabcdefgh.ijklmnopqrstuvwxyz0123456789";
char upwdchars[]="ABCDEFGHIJKLMNPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz123456789.!";
char tmps1[TMPSSIZE];
char command[TMPSSIZE];
char conpass[100]="yeahsure";  // These are compile-time defaults only, you
char mynick[NICKLEN+1]="O2";          // should not change them, use a configfile
char myname[100]="someservice.somenet.org";  // instead.
char conto[100]="someserver.somenet.org";
unsigned int conport=4400;
char sqluser[100]="operserv";
char sqlpass[100]="yeahsure";
char sqlhost[100]="localhost";
char sqldb[100]="operserv";
int sqlport=MYSQL_PORT;
char servernumeric[3];
char uplnum[3]="";
char lastburstchan[520]="";
int lastburstflags=0;
long starttime;  // Timestamp, contains starttime of the service
int burstcomplete=0;  // Is set to 1 once the netburst completed
char logline[2500]="";
char logfile[FILENAME_MAX]="Operservice.log";
char helppath[300]="help/";
long timestdif=0;   // Timestamp-difference
MYSQL sqlcon;
array mainrnl[256];
subnetlist mainsnl[256];
long snlstartsize=1000;
trustedsubnet *tsn;
long tsnsi=1000;
long tsncu=0;
array rngls;
int mfwarn=100;
long lastsettime=0;
long waitingforping=0;
long lasthourly=0;
long lastfakenum=10;
long resyncglinesat=0;
char sendglinesto[20480];
char *noreplytoping=NULL;
array myfakes; /* List of my fakeusers */
char *nicktomsg=NULL;
char params[MAXPARAMS][TMPSSIZE];     // The last line received from the
                                      // server, split at the spaces.
int paramcount;
char sender[TMPSSIZE];
array splitservers;
char modpath[FILENAME_MAX]="/home/fox/O/modules/"; // Path where loadable modules reside.
char modend[10]=".so"; // What filesuffix modules have
array modulelist;      // List of all loaded modules
array commandlist;     // List of all loaded commands
int defaultclonewarn=6;  // Default for warning about clones (6 on quakenet, 0 to disable)
trustedhost * trustedhosts[SIZEOFTL];       // The trusted hosts
array untrustedhosts[SIZEOFHL];     // normal, untrusted hosts
trustedgroup * trustedgroups[SIZEOFIDMAP];

/* End of global variable definitions */

/* Realname-List Functions */

int rnladd(char *realname) {
  unsigned long i; rnlentry *tmpp; unsigned char a;
  a=(unsigned char)realname[0];
  tmpp=(rnlentry *)(mainrnl[a].content);
  for (i=0;i<mainrnl[a].cursi;i++) {
    if (strcmp(realname,tmpp[i].r)==0) {
      tmpp[i].n++;
      return (tmpp[i].n);
    }
  }
  // That realname is not yet in our list. Add it.
  i=array_getfreeslot(&(mainrnl[a]));
  tmpp=(rnlentry *)(mainrnl[a].content);
  tmpp[i].n=1;
  strcpy(tmpp[i].r,realname);
  return 1;
}

void rnldel(char *realname) {
  unsigned long i; rnlentry *tmpp; unsigned char a;
  a=(unsigned char)realname[0];
  tmpp=(rnlentry *)(mainrnl[a].content);
  for (i=0;i<mainrnl[a].cursi;i++) {
    if (strcmp(realname,tmpp[i].r)==0) {
      tmpp[i].n--;
      if (tmpp[i].n<=0) {
        // Nobody on the net has this nick anymore, so we have to kill it from our list
        array_delslot(&(mainrnl[a]),i); i--;
        tmpp=(rnlentry *)(mainrnl[a].content);
      }
      return;
    }
  }
}

/* End of Realname-List functions */

void sighuphandler(int signo) {
  char fuckit[2500];
  /* Of course this is not a clean way to do this, i should rather use a
     semaphore to prevent race conditions. However, this is "good enough".
     The chances something happens here are minimal, and it would only result
     in a weird logentry normally. */
  memcpy(fuckit,logline,2500);
  sprintf(logline,"! Received SIGHUP - ignoring!");
  putlog();
  memcpy(logline,fuckit,2500);
}

/* Userlist functions */

void getuserdata(authdata *retad, char *username) {
  char tmps2[TMPSSIZE], tmps3[TMPSSIZE]; int res;
  MYSQL_RES *myres; MYSQL_ROW myrow;
  retad->authlevel=-1;
  mysql_escape_string(tmps2,username,strlen(username));
  sprintf(tmps3,"SELECT * FROM users WHERE username='%s'",tmps2);
  res=mysql_query(&sqlcon,tmps3);
  if (res!=0) {
    sprintf(logline,"!!! Failed to query user from database !!!"); putlog();
    return;
  }
  myres=mysql_store_result(&sqlcon);
  if (mysql_num_fields(myres)!=6) {
    sprintf(logline,"!!! Userentry in database has invalid format !!!"); putlog();
    return;
  }
  retad->authlevel=0;
  myrow=mysql_fetch_row(myres);
  if (myrow==NULL) { mysql_free_result(myres); return; }
  if (strlen(myrow[0])>AUTHUSERLEN) {
    sprintf(logline,"!!! Authdata in Database contains too long Username: %s !!!",myrow[0]); putlog();
    retad->authlevel=-1; return;
  }
  strcpy(retad->username,myrow[0]);
  if (strlen(myrow[1])>AUTHPASSLEN) {
    sprintf(logline,"!!! Authdata in Database contains too long Password: %s !!!",myrow[1]); putlog();
    retad->authlevel=-1; return;
  }
  strcpy(retad->password,myrow[1]);
  retad->authlevel=atoi(myrow[2]);
  retad->lastauthed=atol(myrow[3]);
  retad->wantsnotice=atoi(myrow[4]);
  retad->noticemask=strtoul(myrow[5],NULL,10);
  mysql_free_result(myres);
}

long countusersinul() {
  int res; MYSQL_RES *myres; long b;
  res=mysql_query(&sqlcon,"SELECT * FROM users");
  if (res!=0) {
    sprintf(logline,"!!! Failed to query users from database !!!"); putlog();
    return -1;
  }
  myres=mysql_store_result(&sqlcon);
  b=mysql_num_rows(myres);
  mysql_free_result(myres);
  return b;
}

void createrandompw(char *a, int n) {
  int b;
  for (b=0;b<n;b++) {
    a[b]=upwdchars[rand()%(sizeof(upwdchars)-1)];
  }
  a[n]='\0';
}

int updateuserinul(authdata ad) {
  char tmps2[TMPSSIZE], tmps3[TMPSSIZE], query[5000];
  int res;
  mysql_escape_string(tmps2,ad.username,strlen(ad.username));
  mysql_escape_string(tmps3,ad.password,strlen(ad.password));
  sprintf(query,"DELETE FROM users WHERE username='%s'",tmps2);
  mysql_query(&sqlcon,query);
  sprintf(query,"INSERT INTO users VALUES('%s','%s',%d,%ld,%d,%lu)",tmps2,tmps3,ad.authlevel,ad.lastauthed,ad.wantsnotice,ad.noticemask);
  res=mysql_query(&sqlcon,query);
  return (res==0);
}

autheduser * getalentry(long unum) {
  autheduser *a;
  a=als;
  while (a!=NULL) {
    if (a->numeric==unum) {
      return a;
    }
    a=(void *)a->next;
  }
  return NULL;
}

void newalentry(long unum) {
  autheduser *a, *b;
  a=als;
  b=(autheduser *) malloc(sizeof(autheduser));
  b->numeric=unum; b->next=NULL;
  if (a==NULL) { als=b; return; }
  while (a!=NULL) {
    if (a->next==NULL) {
      a->next=(void *)b; return;
    }
    a=(void *)a->next;
  }
  sprintf(logline,"!!! This mark in newalentry should never be reached !!!"); putlog();
}

void addautheduser(long unum, authdata ad) {
  autheduser *a;
  a=getalentry(unum);
  if (a==NULL) { newalentry(unum); a=getalentry(unum); }
  strcpy(a->authedas,ad.username);
  a->authlevel=ad.authlevel;
  a->wantsnotice=ad.wantsnotice;
  a->noticemask=ad.noticemask;
}

void delautheduser(long unum) {
  autheduser *a, *b, *c;
  a=als; b=NULL;
  while (a!=NULL) {
    if (a->numeric==unum) {
      c=a;
      if (b!=NULL) {
        b->next=a->next;
      } else {
        als=(void *)a->next;
      }
      free(c);
      return;
    }
    b=a;
    a=(void *)a->next;
  }
}

/* End of Userlist functions */

int opensql(char *host, char *username, char *password, char *database, int port) {
  mysql_init(&sqlcon);
  if (!mysql_real_connect(&sqlcon, host,username,password,database,port,NULL,0)) {
    printf("Error connecting to mysql db.\n");
    return -1;
  }
  return 0;
}

int tcpopen(char *host, unsigned int port) {
  int unit; struct sockaddr_in sin; struct hostent *hp;
  if ((hp=gethostbyname(host)) == NULL) {
    fprintf(stderr,"Oops ... unknown host \"%s\"\n",host);
    return(-1);
  }
  memset((char *)&sin, 0, sizeof(sin));
  if (sizeof(sin.sin_addr)<hp->h_length) {
    fprintf(stderr,"Ooops - host \"%s\" resolves to non IPv4-address\n",host);
    return (-1);
  }
  memcpy((char *)&sin.sin_addr,hp->h_addr,hp->h_length);
  sin.sin_family=hp->h_addrtype;
  sin.sin_port=htons(port);
  if ((unit=socket(AF_INET,SOCK_STREAM,0)) < 0) {
    fprintf(stderr,"Oops ... tcp/ip cannot open socket\n");
    return (-1);
  }
  if (connect(unit,(struct sockaddr *)&sin,sizeof(sin)) < 0) {
    fprintf(stderr,"Oops ... tcp/ip cannot connect to server\n");
    return (-1);
  }
  return(unit);
}

int numericinuse(long num) {
  serverdata *b;
  b=sls;
  while (b!=NULL) {
    if (b->numeric==num) { return 1; }
    b=(void *)b->next;
  }
  return 0;
}

void delchan(char *name) {
  channel *a, *b; unsigned int c;
  c=clhash(name);
  a=cls[c]; b=NULL;
  while (a!=NULL) {
    if (strcmp(a->name,name)==0) {
      // this is the channel we want to delete
      if (b==NULL) {
        cls[c]=(void *)a->next;
      } else {
        b->next=a->next;
      }
      array_free(&(a->users));
      free(a);
      a=NULL;
      return;
    }
    b=a;
    a=(void *)a->next;
  }
}

void deluserfromallchans(long num) {
  channel **c; unsigned long i; userdata *a; char cn[TMPSSIZE];
  i=ulhash(num);
  a=uls[i];
  while (a!=NULL) {
    if (a->numeric==num) {
      while (a->chans.cursi>0) {
        c=(channel **)(a->chans.content);
        strcpy(cn,c[0]->name);
        delchanfromuser(num,cn);
        deluserfromchan(cn,num);
      }
      return;
    }
    a=(void *)a->next;
  }
}

/* delallchanson(unum) - deletes all channels that existed on server with
                         numeric unum (on a split) */
void delallchanson(long num) {
  channel *a, *b, *d; chanuser *c; int i;
  long j;
  for (i=0;i<SIZEOFCL;i++) {
    a=cls[i]; b=NULL;
    while (a!=NULL) {
      c=(chanuser *)a->users.content;
      for (j=0;j < (unsigned long)a->users.cursi;j++) { // Could be problem
        if ((c[j].numeric>>SRVSHIFT)==num) {
          array_delslot(&(a->users),j);
          c=(chanuser *)a->users.content;
          j--;
        }
      }
      if (a->users.cursi==0) { 
        // Delete the channel
        if (b==NULL) {
          cls[i]=(void *)a->next;
        } else {
          b->next=a->next;
        }
        d=(void *)a->next;
        array_free(&(a->users));
        free(a);
        a=d;
      } else {
        b=a;
        a=(void *)a->next;
      }
    }
  }
}

channel * getchanptr(char *name) {
  channel *a;
  a=cls[clhash(name)];
  while (a!=NULL) {
    if (strcmp(a->name,name)==0) {
      return a;
    }
    a=(void *)a->next;
  }
  return NULL;
}

long getsrvnum(char *a) {
  serverdata *b;
  b=sls;
  while (b!=NULL) {
    if (strcmp(b->nick,a)==0) { return b->numeric; }
    b=(void *)b->next;
  }
  return -1;
}

int serverdoesnotreplytopings(serverdata *s) {
  char *tmps; char *a;
  if (s->connectedto==tokentolong(servernumeric)) { return 1; }
  if (noreplytoping==NULL) { return 0; }
  tmps=(char *)malloc(strlen(noreplytoping)+1);
  strcpy(tmps,noreplytoping);
  a=strtok(tmps," ");
  while (a!=NULL) {
    if (strcmp(s->nick,a)==0) {
      free(tmps); return 1;
    }
    a=strtok(NULL," ");
  }
  free(tmps);
  return 0;
}

void pingallservers() {
  serverdata *b; char tmps2[TMPSSIZE];
  b=sls;
  while (b!=NULL) {
    b->pingreply=0; b->pingsent=getnettime(); strcpy(b->ports,"");
    longtotoken(b->numeric,tmps2,2);
    fprintf(sockout,"%sAAB R u %s\r\n",servernumeric,tmps2);
    fprintf(sockout,"%sAAB R P %s\r\n",servernumeric,tmps2);
    b=(void *)b->next;
  }
  fflush(sockout);
}

long countusershit(char *pattern) {
  userdata *a; long howmany=0; char tmps2[TMPSSIZE], tmps3[TMPSSIZE]; int i;
  channel *c; int icis; char tmps4[TMPSSIZE]; unsigned int x1,x2,x3,x4;
  icis=0;
  if ((pattern[0]=='#') || (pattern[0]=='+') || (pattern[0]=='&')) { /* Channelgline */
    for (i=0;i<SIZEOFCL;i++) {
      c=cls[i];
      strcpy(tmps2,pattern); toLowerCase(tmps2);
      while (c!=NULL) {
        strcpy(tmps3,c->name);
        if (match2strings(tmps2,tmps3)) {
          howmany++;
        }
        c=(void *)c->next;
      }
    }
  } else {
    if (ischarinstr('!',pattern)) { icis=1; }
    for (i=0;i<SIZEOFUL;i++) {
      a=uls[i];
      strcpy(tmps2,pattern);
      toLowerCase(tmps2);
      while (a!=NULL) {
        splitip(a->realip,&x1,&x2,&x3,&x4);
        if (icis==1) {
          sprintf(tmps3,"%s!%s@%s",a->nick,a->ident,a->host);
          sprintf(tmps4,"%s!%s@%u.%u.%u.%u",a->nick,a->ident,x1,x2,x3,x4);
        } else {
          sprintf(tmps3,"%s@%s",a->ident,a->host);
          sprintf(tmps4,"%s@%u.%u.%u.%u",a->ident,x1,x2,x3,x4);
        }
        toLowerCase(tmps3); toLowerCase(tmps4);
        if ((match2strings(tmps2,tmps3)) || (match2strings(tmps2,tmps4))) {
          howmany++;
        }
        a=(void *)a->next;
      }
    }
  }
  return howmany;
}

void noticeallircops(char *thetext) {
  userdata *a; char target[10]; int i;
  for (i=0;i<SIZEOFUL;i++) {
    a=uls[i];
    while (a!=NULL) {
      if (ischarinstr('o',a->umode)) {
        longtotoken(a->numeric,target,5);
        fprintf(sockout,"%sAAB O %s :%s\r\n",servernumeric,target,thetext);
      }
      a=(void *)a->next;
    }
  }
  fflush(sockout);
}

void delalluserson(long num) {
  userdata *a, *b, *c; int i;
  for (i=0;i<SIZEOFUL;i++) {
    a=uls[i]; b=NULL;
    while (a!=NULL) {
      if ((a->numeric>>SRVSHIFT)==num) {
        delautheduser(a->numeric);
        delfromnicklist(a->nick);
        snldel(&(mainsnl[a->realip>>24]),a->realip);
        rnldel(a->realname);
        trustdelclient(a->ident,a->host);
        c=a;
        if (b==NULL) {
          uls[i]=(void *)a->next;
        } else {
          b->next=a->next;
        }
        a=(void *)a->next;
        array_free(&(c->chans));
        free(c);
      } else {
        b=a;
        a=(void *)a->next;
      }
    }
  }
}

void delsrv(char *a) {
  long num; char tmps2[100];
  serverdata *b, *c;
  num=getsrvnum(a);
  longtotoken(num,tmps2,2);
  sprintf(logline,"Lost server: %s (Numeric %s)",a,tmps2); putlog();
  addsplit(a);
  delallchanson(num);
  delalluserson(num);
  b=sls; c=NULL;
  while (b!=NULL) {
    if (b->numeric==num) {
      if (c==NULL) {
        sls=(void *)b->next;
      } else {
        c->next=b->next;
      }
      free(b);
      b=sls; c=NULL;
      while (b!=NULL) {
        if (b->connectedto==num) {
          delsrv(b->nick);
          b=sls; c=NULL;
        } else {
          c=b;
          b=(void *)b->next;
        }
      }
      return;
    }
    c=b;
    b=(void *)b->next;
  }
}

void deluserfromchan(char *name, long numeric) {
  channel *a; chanuser *b;
  unsigned long i;
//  printf("Deluser %d from %s\n",numeric,name);
  a=getchanptr(name);
  if (a==NULL) {
    sprintf(logline,"!!! Attempt to kill user from nonexistant channel %s !!!",name); putlog();
    return;
  }
  if (a->users.cursi==0) {
    sprintf(logline,"!!! Attempt to kill user from empty channel %s !!!",name); putlog();
    return;
  }
  b=(chanuser *)a->users.content;
  if (b==NULL) { return; }
  for (i=0;i<a->users.cursi;i++) {
    if (b[i].numeric==numeric) {
      array_delslot(&(a->users),i);
      i--;
      b=(chanuser *)a->users.content;   /* Can't believe i forgot that, ARGH */
    }
  }
  if (a->users.cursi==0) {
    // The channel is now empty, this was the last user in it
    delchan(name);
  }
}

void addnicktoul(userdata *a) {
  int i;
  i=ulhash(a->numeric);
  a->next=(void *)uls[i];
  uls[i]=a;
}

void addchantouser(userdata *a, channel *c) {
  int i; channel **d;
  i=array_getfreeslot(&(a->chans));
  d=(channel **)(a->chans.content);
  d[i]=c;
}

void addchantouser2(long num, channel *c) {
  userdata *a; unsigned int i;
  i=ulhash(num);
  if (i>=SIZEOFUL) {
    sprintf(logline,"!!! Warning: ulhash returned value out of range! (%u) !!!",i); putlog();
    printf("Lastline was: %s\n",lastline);
    return;
  }
  a=uls[i];
  while (a!=NULL) {
    if (a->numeric==num) {
      addchantouser(a,c);
      return;
    }
    a=(void *)a->next;
  }
}

void delchanfromuser(long num, char *channam) {
  unsigned long i; channel **d; userdata *a; unsigned int j;
  j=ulhash(num);
  a=uls[j];
  while (a!=NULL) {
    if (a->numeric==num) {
      d=(channel **)(a->chans.content);
      for (i=0;i<a->chans.cursi;i++) {
        if (strcmp(channam,d[i]->name)==0) {
          array_delslot(&(a->chans),i);
          return;
        }
      }
      return;
    }
    a=(void *)a->next;
  }
}

void newserver(char *nick, int hopsaway, long numeric, long createdat, long connectat, long connectedto, long maxclients) {
  serverdata *a; char tmps2[100];
  longtotoken(numeric,tmps2,2);
  sprintf(logline,"New Server: %s (Numeric %s)",nick,tmps2); putlog();
  a=(serverdata *) malloc(sizeof(serverdata));
  a->hopsaway=hopsaway;
  a->numeric=numeric;
  a->createdat=createdat; a->connectat=connectat;
  a->connectedto=connectedto; a->maxclients=maxclients;
  a->pingreply=0; a->pingsent=0;
  strcpy(a->ports,"");
  if (strlen(nick)>SRVLEN) {
    sprintf(logline,"!!! SERVERNAME exceeds maxlength! | %s | !!!",lastline); putlog();
  }
  strncpy(a->nick,nick,SRVLEN);
  a->nick[SRVLEN]='\0';
  if (burstcomplete==1) { changesplitstatus(a->nick,1); }
  a->next=(void *)sls;
  sls=a;
}

int chanexists(char *name) {
  channel *a;
  a=cls[clhash(name)];
  while (a!=NULL) {
    if (strcmp(name,a->name)==0) { return 1; }
    a=(void *)a->next;
  }
  return 0;
}

channel * newchan(char *name, long createdat) {
  channel *a; unsigned int b;
//  if (name[0]!='#') { printf("New strange channel: %s \n",name); }
  a=(channel *) malloc(sizeof(channel));
  strcpy(a->name,name);
  a->createdat=createdat;
  a->flags=0;
  array_init(&(a->users),sizeof(chanuser));
  array_setlim1(&(a->users),10);
  array_setlim2(&(a->users),15);
  a->bans=NULL;
  strcpy(a->topic,"");
  b=clhash(name);
  a->next=(void *)cls[b];
  cls[b]=a;
  return a;
}

void setchankey(char *name, char *key) {
  channel *a;
  a=getchanptr(name);
  if (a!=NULL) { mystrncpy(a->chankey,key,CHANKEYLEN); }
}

void setchanke2(channel *a, char *key) {
  mystrncpy(a->chankey,key,CHANKEYLEN);
}

void setchanlim(char *name, int lim) {
  channel *a;
  a=getchanptr(name);
  if (a!=NULL) { a->chanlim=lim; }
}

void setchanli2(channel *a, int lim) {
  a->chanlim=lim;
}

void setchanflag(char *name, int flags) {
  channel *a;
  a=getchanptr(name);
  if (a!=NULL) { a->flags=(a->flags | flags); }
}

void delchanflag(char *name, int flags) {
  channel *a;
  a=getchanptr(name);
  if (a!=NULL) { a->flags=(a->flags & (~flags)); }
}

void setchanfla2(channel *a, int flags) {
  a->flags=(a->flags | flags);
}

void delchanfla2(channel *a, int flags) {
  a->flags=(a->flags & (~flags));
}

void addusertocptr(channel *b, long numeric) {
  chanuser *a; unsigned long i;
  i=array_getfreeslot(&(b->users));
  a=(chanuser *)b->users.content;
  a[i].numeric=numeric;
  a[i].flags=0;
}

void addusertochan(char *name, long numeric) {
  channel *b;
  b=getchanptr(name);
  if (b==NULL) {
    sprintf(logline,"!!! Attempt to add user to nonexistant channel %s !!!",name); putlog();
    return;
  }
  addusertocptr(b,numeric);
}

void addgline(char *hostmask, char *reason, char *bywhom, long howlong, int sendtonet) {
  int res; char escapedhm[TMPSSIZE], escapedreas[TMPSSIZE], escapedbywhom[TMPSSIZE]; char query[5000]="";
  if (howlong==0) { return; }
  if (sendtonet!=0) {
    fprintf(sockout,"%s GL * +%s %ld :%s\r\n",servernumeric,hostmask,howlong,reason);
    fflush(sockout);
  }
  mysql_escape_string(escapedhm,hostmask,strlen(hostmask));
  mysql_escape_string(escapedreas,reason,strlen(reason));
  mysql_escape_string(escapedbywhom,bywhom,strlen(bywhom));
  sprintf(query,"DELETE FROM glines WHERE hostmask='%s'",escapedhm);
  mysql_query(&sqlcon,query);
  sprintf(query,"INSERT INTO glines values('%s','%s',%ld,'%s')",escapedhm,escapedbywhom,(howlong+getnettime()),escapedreas);
//  printf("%s\n",query);
  res=mysql_query(&sqlcon,query);
  if (res!=0) {
    sprintf(logline,"!!! Failed to insert gline into database !!!"); putlog();
    return;
  }
}

void remgline(char *hostmask, int sendtonet) {
  int res; char escapedhm[TMPSSIZE]; char query[5000]="";
  if (sendtonet!=0) {
    fprintf(sockout,"%s GL * -%s\r\n",servernumeric,hostmask);
    fflush(sockout);
  }
  mysql_escape_string(escapedhm,hostmask,strlen(hostmask));
  sprintf(query,"DELETE FROM glines WHERE hostmask='%s'",escapedhm);
  res=mysql_query(&sqlcon,query);
  if (res!=0) {
    sprintf(logline,"!!! Failed to remove gline '%s' from database !!!",hostmask); putlog();
    return;
  }
}

void purgeglines() {
  int res; char query[TMPSSIZE];
  sprintf(query,"DELETE FROM glines WHERE expires<%ld",(long int)getnettime());
  res=mysql_query(&sqlcon,query);
  if (res!=0) {
    sprintf(logline,"!!! GLINE-Purge returned error !!!"); putlog();
    return;
  }
}

int gotallpingreplys() {
  serverdata *s;
  s=sls;
  while (s!=NULL) {
    if (s->pingreply==0) {
      if (serverdoesnotreplytopings(s)!=1) { return 0; }
    }
    s=(void *)s->next;
  }
  return 1;
}

long getmaxping() {
  serverdata *s; long maxping;
  s=sls; maxping=-1;
  while (s!=NULL) {
    if (s->pingreply!=0) {
      if ((s->pingreply-s->pingsent)>maxping) { maxping=s->pingreply-s->pingsent; }
    }
    s=(void *)s->next;
  }
  return maxping;
}

void changechanmod2(channel *a, long numeric, int sm, int flags) {
  // sm = Setmode: 0 = set flags, 1 = add flags, 2 = remove flags
  chanuser *b; unsigned long i;
  b=(chanuser *)a->users.content;
  for (i=0;i<a->users.cursi;i++) {
    if (b[i].numeric==numeric) {
      if (sm==0) { b[i].flags=flags; }
      if (sm==1) { b[i].flags=(b[i].flags | flags); }
      if (sm==2) { b[i].flags=(b[i].flags & (~ flags)); }
      return;
    }
  }
  sprintf(logline,"!!! Mode change for nonexistant user on %s !!!",a->name); putlog();
}

void changechanmode(char *name, long numeric, int sm, int flags) {
  // sm = Setmode: 0 = set flags, 1 = add flags, 2 = remove flags
  channel *a;
  a=getchanptr(name);
  if (a==NULL) {
    sprintf(logline,"!!! Mode change for nonexistant channel %s !!!",name); putlog();
    return;
  }
  changechanmod2(a,numeric,sm,flags);
}

int getchanmode2(channel *a, long numeric) {
  chanuser *b; unsigned long i;
  b=(chanuser *)a->users.content;
  for (i=0;i<a->users.cursi;i++) {
    if (b[i].numeric==numeric) {
      return b[i].flags;
    }
  }
  return -1;
}

int getchanmodes(char *name, long numeric) {
  channel *a;
  a=getchanptr(name);
  if (a==NULL) { return -1; } else { return getchanmode2(a,numeric); }
}

int loadconfig(char *filename) {
  FILE *myf; char myline[1024]; char *res;
  char tmps2[TMPSSIZE], tmps3[TMPSSIZE]; int r2;
  myf=fopen(filename,"r");
  if (myf==NULL) { return (-1); }
  do {
    res=fgets(myline,1024,myf);
    delchar(myline,'\n');
    delchar(myline,'\r');
    if ((myline[0]!='\0') && (myline[0]!='#')) {
      // This line is not a comment, we'll have to parse it
      r2=sscanf(myline,"%[^=]%[^\n]",tmps2,tmps3);
      if (r2!=2) {
        printf("Illegal line format in configfile: %s\n",myline);
      } else {
        delchar(tmps3,'=');
//        printf("%s // %s\n",tmps2,tmps3);
        if (strcmp(tmps2,"mynick")==0) { strcpy(mynick,tmps3); }
        if (strcmp(tmps2,"myname")==0) { strcpy(myname,tmps3); }
        if (strcmp(tmps2,"conto")==0) { strcpy(conto,tmps3); }
        if (strcmp(tmps2,"conport")==0) { conport=strtoul(tmps3,NULL,10); }
        if (strcmp(tmps2,"conpass")==0) { strcpy(conpass,tmps3); }
        if (strcmp(tmps2,"numeric")==0) { longtotoken(atoi(tmps3),servernumeric,2); }
        if (strcmp(tmps2,"sqlhost")==0) { strcpy(sqlhost,tmps3); }
        if (strcmp(tmps2,"sqlport")==0) { sqlport=atol(tmps3); }
        if (strcmp(tmps2,"sqluser")==0) { strcpy(sqluser,tmps3); }
        if (strcmp(tmps2,"sqlpass")==0) { strcpy(sqlpass,tmps3); }
        if (strcmp(tmps2,"sqldb")==0) { strcpy(sqldb,tmps3); }
        if (strcmp(tmps2,"logfile")==0) { strcpy(logfile,tmps3); }
        if (strcmp(tmps2,"helppath")==0) { strcpy(helppath,tmps3); }
        if (strcmp(tmps2,"modpath")==0) { strcpy(modpath,tmps3); }
        if (strcmp(tmps2,"modend")==0) { strcpy(modend,tmps3); }
        if (strcmp(tmps2,"mfwarn")==0) { mfwarn=atoi(tmps3); }
        if (strcmp(tmps2,"clonewarn")==0) { defaultclonewarn=atoi(tmps3); }
        if (strcmp(tmps2,"loadmod")==0) { 
          int res;
          res=loadandinitmodule(tmps3);
          if (res==0) {
            sprintf(logline,"Module loaded successfully: %s",tmps3);
          } else {
            sprintf(logline,"Failed to load module: %s",tmps3);
          }
          putlog();
        }
        if (strcmp(tmps2,"noreplytoping")==0) {
          if (noreplytoping==NULL) {
            noreplytoping=(char *)malloc(strlen(tmps3)+1);
            strcpy(noreplytoping,tmps3);
          } else {
            noreplytoping=(char *)realloc(noreplytoping,strlen(noreplytoping)+strlen(tmps3)+2);
            strcat(noreplytoping," ");
            strcat(noreplytoping,tmps3);
          }
        }
      }
    } else {
//      printf("Line ignored: %s\n",myline);
    }
  } while (res!=NULL);
  return 0;
}

void numtonick(long num, char *res) {
  userdata *a;
  a=uls[ulhash(num)];
  while (a!=NULL) {
    if (num==a->numeric) {
      strcpy(res,a->nick);
      return;
    }
    a=(void *)a->next;
  }
  strcpy(res,"");
  sprintf(logline,"!!! Failed to convert numeric %ld to nick !!!",num); putlog();
}

void numtohostmask(long num, char *res) {
  userdata *a;
  a=uls[ulhash(num)];
  while (a!=NULL) {
    if (num==a->numeric) {
      sprintf(res,"%s!%s@%s",a->nick,a->ident,a->host);
      return;
    }
    a=(void *)a->next;
  }
  strcpy(res,"");
  sprintf(logline,"!!! Failed to convert numeric %ld to hostmask !!!",num); putlog();
}

int alreadyinglinesto(char *nick) {
  char tmps2[25000]; char *tmps3, *tmps4;
  strcpy(tmps2,sendglinesto);
  tmps3=strtok_r(tmps2,",",&tmps4);
  while (tmps3!=NULL) {
    if (strcmp(tmps3,nick)==0) { return 1; }
    tmps3=strtok_r(NULL,",",&tmps4);
  }
  return 0;
}

void dumpuserlist() {
  userdata *a; int i;
  for (i=0;i<SIZEOFUL;i++) {
    a=uls[i];
    while (a!=NULL) {
      printf("Nick: %s ; Realname: %s\n",a->nick,a->realname);
      a=(void *)a->next;
    }
  }
}

long nicktonu2(char *a) {
  userdata **b; long i; unsigned int hash;
  hash=nlhash(a);
  b=(userdata **)nls[hash].content;
  for (i=0;i<nls[hash].cursi;i++) {
    if (strcmp(b[i]->nick,a)==0) {
      return b[i]->numeric;
    }
  }
  return -1;
}

long nicktonum(char *a) {
  long c;
  c=nicktonu2(a);
  if (c==-1) {
    sprintf(logline,"!!! Couldnt translate nick %s to numeric !!!",a); putlog();
  }
  return c;
}

long countusersonthenet() {
  userdata *a; long tmpl; int i;
  tmpl=0;
  for (i=0;i<SIZEOFUL;i++) {
    a=uls[i];
    while (a!=NULL) {
      tmpl++;
      a=(void *)a->next;
    }
  }
  return tmpl;
}

long countusersonsrv(long num) {
  userdata *a; long n=0; int i;
  for (i=0;i<SIZEOFUL;i++) {
    a=uls[i];
    while (a!=NULL) {
      if ((a->numeric>>SRVSHIFT)==num) { n++; }
      a=(void *)a->next;
    }
  }
  return n;
}

void showhelp(long unum, char *command) {
  FILE *helpfile; char fnam[TMPSSIZE]; char tmps2[TMPSSIZE]; char *res;
  strcpy(fnam,helppath);
  strcpy(tmps2,command);
  toLowerCase(tmps2);
  delchar(tmps2,'/');
  delchar(tmps2,'\\');
  delchar(tmps2,':');
  delchar(tmps2,'.');
  strcat(fnam,tmps2);
  strcat(fnam,".help");
  helpfile=fopen(fnam,"r");
  if (helpfile==NULL) {
    msgtouser(unum,"No help available for that.");
    return;
  }
  do {
    res=fgets(tmps2,300,helpfile);
    if (res!=NULL) {
      delchar(tmps2,'\r');
      delchar(tmps2,'\n');
      msgtouser(unum,tmps2);
    }
  } while (res!=NULL);
  msgtouser(unum,"--- End of help ---");
  fclose(helpfile);
}

void glinesync() {
  int res; MYSQL_RES *myres; MYSQL_ROW myrow; unsigned long i; char *tmps2, *tmps3; char FICKEN[20480];
  purgeglines();
  strcpy(FICKEN,sendglinesto);
  FICKEN[400]='\0';
  sprintf(logline,"Resyncing glines to %s",FICKEN); putlog();
  res=mysql_query(&sqlcon,"SELECT * FROM glines");
  if (res!=0) {
    sprintf(logline,"!!! Failed to query gline-list from database !!!"); putlog();
    return;
  }
  myres=mysql_store_result(&sqlcon);
  if (mysql_num_fields(myres)!=4) {
    sprintf(logline,"!!! GList in database has invalid format !!!"); putlog();
    return;
  }
  i=0;
  while ((myrow=mysql_fetch_row(myres))) {
    strcpy(FICKEN,sendglinesto);
    tmps3=strtok_r(FICKEN,",",&tmps2);
    while (tmps3!=NULL) {
      fprintf(sockout,"%s GL %s +%s %ld :%s\r\n",servernumeric,tmps3,myrow[0],atol(myrow[2])-getnettime(),myrow[3]);
      tmps3=strtok_r(NULL,",",&tmps2);
      i++;
      if ((i%1000)==0) { sprintf(logline,"%lu",i); putlog(); }
    }
  }
  fflush(sockout);
  strcpy(sendglinesto,"");
  mysql_free_result(myres);
  sprintf(logline,"Done, %lu total.",i); putlog();
}

void saveall() {
  savetrustlist();  /* subnet-trusts */
  rnglsave();
  fakeusersave();
  savetrusts();     /* host trustgroups */
}

void dochanneljoins() {
  MYSQL_RES *sqlres; unsigned int numfields;
  MYSQL_ROW sqlrow; int res; channel *ctmp;
  res=mysql_query(&sqlcon,"SELECT * FROM channels");
  if (res!=0) {
    sprintf(logline,"!!! Could not read my channellist from the database !!!"); putlog();
    return;
  }
  sqlres=mysql_store_result(&sqlcon);
  numfields=mysql_num_fields(sqlres);
  if (numfields!=1) {
    sprintf(logline,"!!! Channellist has illegal format !!!"); putlog();
    mysql_free_result(sqlres);
    return;
  }
  while ((sqlrow=mysql_fetch_row(sqlres))) {
    toLowerCase(sqlrow[0]);
    if (!chanexists(sqlrow[0])) {
      ctmp=newchan(sqlrow[0],starttime);
      fprintf(sockout,"%sAAB C %s %ld\r\n",servernumeric,sqlrow[0],starttime);
    } else {
      ctmp=getchanptr(sqlrow[0]);
      fprintf(sockout,"%sAAB J %s\r\n",servernumeric,sqlrow[0]);
      fprintf(sockout,"%s M %s +o %sAAB\r\n",servernumeric,sqlrow[0],servernumeric);
    }
    addusertocptr(ctmp,(tokentolong(servernumeric)<<SRVSHIFT)+1);
    changechanmod2(ctmp,(tokentolong(servernumeric)<<SRVSHIFT)+1,0,um_o);
  }
  fflush(sockout);
  mysql_free_result(sqlres);
}

void addtonicklist(userdata *a) {
  userdata **b; long l; unsigned int hash;
  hash=nlhash(a->nick);
  l=array_getfreeslot(&(nls[hash]));
  b=(userdata **)nls[hash].content;
  b[l]=a;
}

void delfromnicklist(char *nick) {
  long l; unsigned int hash; userdata **a;
  hash=nlhash(nick);
  a=(userdata **)nls[hash].content;
  for (l=0;l<nls[hash].cursi;l++) {
    if (strcmp(a[l]->nick,nick)==0) {
      array_delslot(&(nls[hash]),l); l--;
      a=(userdata **)nls[hash].content;
    }
  }
}

void lastlinesplit() {
  char *c; int i;
  c=&lastline[0]; paramcount=0; i=0;
  for (;((*c!='\n') && (*c!='\0') && (*c!='\r') && (paramcount<(MAXPARAMS-2)));c++) {
    if (*c==' ') {
      params[paramcount][i]='\0';
      paramcount++; i=0;
      while (*(c+1)==' ') { c++; }
    } else {
      params[paramcount][i]=*c;
      i++;
    }
  }
  params[paramcount][i]='\0';
  paramcount++;
}

int main(int argc, char **argv) {
  int whatever; char prevline[TMPSSIZE]; int iii; struct sigaction sa; unsigned long trustres;
  burstcomplete=0; sls=NULL;
  /* Install signalhandler */
  sa.sa_handler=sighuphandler;
  sigemptyset(&sa.sa_mask);
  sa.sa_flags=0;
  sigaction(SIGHUP,&sa,NULL);
  for (iii=0;iii<SIZEOFUL;iii++) {
    uls[iii]=NULL;
  }
  for (iii=0;iii<SIZEOFCL;iii++) {
    cls[iii]=NULL;
  }
  for (iii=0;iii<SIZEOFTL;iii++) {
    trustedhosts[iii]=NULL;
  }
  for (iii=0;iii<SIZEOFIDMAP;iii++) {
    trustedgroups[iii]=NULL;
  }
  for (iii=0;iii<SIZEOFHL;iii++) {
    array_init(&(untrustedhosts[iii]),sizeof(hostcounter));
  }
  for (iii=0;iii<SIZEOFNL;iii++) {
    array_init(&(nls[iii]),sizeof(userdata *));
    array_setlim1(&(nls[iii]),50);
    array_setlim2(&(nls[iii]),75);
  }
  array_init(&modulelist,sizeof(loadedmod));
  array_setlim1(&modulelist,50);
  array_setlim2(&modulelist,75);
  array_init(&commandlist,sizeof(dyncommands));
  array_setlim1(&commandlist,50);
  array_setlim2(&commandlist,75);
  strcpy(sendglinesto,"");
  numcf=sizeof(chanflags)/sizeof(flags);
  numuf=sizeof(userflags)/sizeof(flags);
  timestdif=0;
  longtotoken(62,servernumeric,2);
  srand(time(NULL)%24167);
  if (argc>1) {
    sprintf(logline,"Trying to load config: %s...",argv[1]); putlog();
    if (loadconfig(argv[1])<0) {
      sprintf(logline,"FAILED"); putlog();
    } else {
      sprintf(logline,"done."); putlog();
    }
  } else {
    sprintf(logline,"Trying to load default config Operservice.conf..."); putlog();
    if (loadconfig("Operservice.conf")<0) {
      sprintf(logline,"FAILED"); putlog();
    } else {
      sprintf(logline,"done."); putlog();
    }
  }
  nicktomsg=(char *)malloc(strlen(mynick)+strlen(myname)+2);
  if (nicktomsg==NULL) {
    printf("Out of memory. BIG BAD CRASH.\n"); exit(1);
  }
  strcpy(nicktomsg,mynick);
  strcat(nicktomsg,"@");
  strcat(nicktomsg,myname);
  toLowerCase(nicktomsg);
  sprintf(logline,"Trying to open SQL-Connection..."); putlog();
  whatever=opensql(sqlhost,sqluser,sqlpass,sqldb,sqlport);
  if (whatever<0) {
    sprintf(logline,"Connection to SQL-Server on %s failed. exiting.",sqlhost); putlog();
    return -2;
  }
  sprintf(logline,"SQL-Connection succeeded, executing create-querys..."); putlog();
  mysql_query(&sqlcon,"CREATE TABLE channels (name varchar(250) NOT NULL, PRIMARY KEY (name), UNIQUE name (name))");
  mysql_query(&sqlcon,"CREATE TABLE glines (hostmask varchar(250) NOT NULL, creator varchar(100) NOT NULL, expires bigint(20) DEFAULT '0' NOT NULL, reason varchar(255) NOT NULL, PRIMARY KEY (hostmask))");
  mysql_query(&sqlcon,"CREATE TABLE users (username varchar(40) NOT NULL, password varchar(40) NOT NULL, authlevel int(11) DEFAULT '0' NOT NULL, lastauthed bigint, wantsnotice int DEFAULT 0, noticemask bigint DEFAULT 0, PRIMARY KEY (username), UNIQUE username (username))");
  mysql_query(&sqlcon,"CREATE TABLE sntrustlist (a INT, b INT, c INT, n INT, expires BIGINT, reason VARCHAR(200))");
  mysql_query(&sqlcon,"CREATE TABLE realnameglines (mask VARCHAR (150) not null , howtogline INT not null , creator VARCHAR(40) , expires BIGINT , reason VARCHAR (100) not null , PRIMARY KEY (mask), INDEX (mask), UNIQUE (mask))");
  mysql_query(&sqlcon,"CREATE TABLE fakeusers (nick VARCHAR (40) not null , ident VARCHAR (40) not null , host VARCHAR (200) not null , realname VARCHAR (200) not null , PRIMARY KEY (nick), INDEX (nick), UNIQUE (nick))");
  mysql_query(&sqlcon,"CREATE TABLE trustgroups (ID BIGINT not null , name VARCHAR (70) not null , trustedfor INT not null , expires BIGINT not null , maxperident INT not null , enforceident INT not null , contact VARCHAR (150) not null , comment VARCHAR (200) not null , PRIMARY KEY (ID), UNIQUE (ID))");
  mysql_query(&sqlcon,"CREATE TABLE trustedhosts (hostname VARCHAR (100) not null , groupid BIGINT not null , PRIMARY KEY (hostname), UNIQUE (hostname))");
  sprintf(logline,"Tables should have been created if they didn't exist before."); putlog();
  for (iii=0;iii<256;iii++) {
    snlcreate(&(mainsnl[iii]),snlstartsize);
  }
  createtl();   /* Subnet-Trustlist */
  loadtrustlist(); /* Subnet-Trustlist */
  trustres=loadtrusts();    /* Host-Trustgroups */
  sprintf(logline,"Loaded %lu trustgroups and %lu trusted hosts from database",trustres>>16,trustres & 0xFFFF); putlog();
  rnglcreate();
  rnglload();
  for (iii=0;iii<256;iii++) {
    array_init(&mainrnl[iii],sizeof(rnlentry));
  }
  array_init(&myfakes,sizeof(afakeuser));
  createfakeuser((tokentolong(servernumeric)<<SRVSHIFT)+1,mynick,"operserv","localhost","This is Operservice V2.X",0);
  array_init(&splitservers,sizeof(splitserv));
  addsplit("dummy_to_prevent_ops_if_net_is_split_and_o_doesnt_know_yet");
  sprintf(logline,"Connecting to %s Port %u",conto,conport); putlog();
  whatever=tcpopen(conto,conport);
  if (whatever<0) {
    sprintf(logline,"Connection failed."); putlog();
    return -1;
  }
  sprintf(logline,"Connection accepted."); putlog();
  sockin=fdopen(whatever,"r");
  sockout=fdopen(whatever,"w");
  fprintf(sockout,"PASS %s\r\n",conpass);
  starttime=time(NULL);
  lastsettime=starttime; waitingforping=0;
  lasthourly=starttime;
  longtotoken(iptolong(127,0,0,1),tmps1,6);
  fprintf(sockout,"SERVER %s 1 %ld %ld J10 %sA]] 0 :This is operservice %s\r\n",myname,starttime,starttime,servernumeric,operservversion);
  fprintf(sockout,"%s N %s 1 %ld operserv %s +odk %s %sAAB :This is operservice %s\r\n",servernumeric,mynick,starttime,myname,tmps1,servernumeric,operservversion);
  fprintf(sockout,"%s EB\r\n",servernumeric);
  fflush(sockout);
  do {
    strcpy(prevline,lastline);
    lastline[0]='\0'; command[0]='\0';
    do {
      errno=0;
      fgets(lastline,513,sockin);
    } while (errno==EINTR);
    /* Remove the trailing linefeed */
    if (strlen(lastline)>0) {
      delchar(lastline,'\r');
      delchar(lastline,'\n');
    }
    if (lastline[0]!='\0') {
      long cuneti; // Current net time
      cuneti=getnettime();
      if ((lasthourly+3600)<cuneti) {
        sprintf(logline,"Starting hourly duties..."); putlog();
        saveall();
        purgeglines();
        splitpurge();
        lasthourly=getnettime();
        sprintf(logline,"Hourly duties done."); putlog();
      }
      if (resyncglinesat!=0) {
        if (resyncglinesat<=cuneti) {
          glinesync();
          // Time to synch the glines
          resyncglinesat=0;
        }
      }    
      if ((lastsettime+3600)<cuneti) {
        // Last settime was 1 hour ago, time to do it again
        if (waitingforping==0) {
          waitingforping=cuneti;
          pingallservers();
        } else {
          if ((waitingforping+60)<cuneti) {
            // OK, we pinged 60 seconds ago, but still not all replied.
            // don't do settime now. Try again in 5 minutes
            sprintf(logline,"! Networklag >1 minute! Cannot do settime! Will try again in 5 min"); putlog();
            lastsettime+=6*60; waitingforping=0;
          }
        }
      }
      lastlinesplit();
      if (paramcount<2) { strcpy(command,""); } else { strcpy(command,params[1]); }
//      sprintf(logline,"%s",lastline); putlog();
      if (strcmp(params[0],"SERVER")==0) {
        handleservermsg(1);
        sprintf(logline,"I am connected to numeric: %s",uplnum); putlog();
      } else if (strcmp(params[0],"PASS")==0) {
        sprintf(logline,"Got password (and dont give a fuck about it)"); putlog();
      } else {
        somethingtonumeric(params[0],sender);
        if ((strcmp(command,"END_OF_BURST")==0) || (strcmp(command,"EB")==0)) {
          if (strcmp(sender,uplnum)==0) {
            sprintf(logline,"Sending EOB_ACK"); putlog();
            fprintf(sockout,"%s EA\r\n",servernumeric); fflush(sockout);
            burstcomplete=1;
            sprintf(logline,"Merge took %ld seconds.",(time(NULL)-starttime)); putlog();
            sprintf(logline,"Joining channels and creating fakeusers"); putlog();
            dochanneljoins();
            fakeuserload();
            sprintf(logline,"Done."); putlog();
            pingallservers(); waitingforping=getnettime(); lastsettime=getnettime()-3600;
          }
        }
        if ((strcmp(command,"NICK")==0) || (strcmp(command,"N")==0)) { handlenickmsg(); }
        if ((strcmp(command,"QUIT")==0) || (strcmp(command,"Q")==0)) { handlequitmsg(); }
        if ((strcmp(command,"KILL")==0) || (strcmp(command,"D")==0)) { handlekillmsg(); }
        if ((strcmp(command,"SERVER")==0) || (strcmp(command,"S")==0)) { handleservermsg(0); }
        if ((strcmp(command,"PING")==0) || (strcmp(command,"G")==0)) { handleping(); }
        if ((strcmp(command,"MODE")==0) || (strcmp(command,"M")==0)) { handlemodemsg(); }
        if ((strcmp(command,"PRIVMSG")==0) || (strcmp(command,"P")==0)) { handleprivmsg(); }
        if ((strcmp(command,"SQUIT")==0) || (strcmp(command,"SQ")==0)) { handlesquit(); }
        if ((strcmp(command,"BURST")==0) || (strcmp(command,"B")==0)) { handleburstmsg(); }
        if ((strcmp(command,"CREATE")==0) || (strcmp(command,"C")==0)) { handlecreatemsg(); }
        if ((strcmp(command,"JOIN")==0) || (strcmp(command,"J")==0)) { handlejoinmsg(); }
        if ((strcmp(command,"PART")==0) || (strcmp(command,"L")==0)) { handlepartmsg(); }
        if ((strcmp(command,"KICK")==0) || (strcmp(command,"K")==0)) { handlekickmsg(); }
        if ((strcmp(command,"GLINE")==0) || (strcmp(command,"GL")==0)) { handleglinemsg(); }
        if ((strcmp(command,"STATS")==0) || (strcmp(command,"R")==0)) { handlestatsmsg(); }
        if (strcmp(command,"242")==0) { handlestatsureply(); }
        if (strcmp(command,"217")==0) { handlestatsPreply(); }
        if ((strcmp(command,"EOB_ACK")==0) || (strcmp(command,"EA")==0)) { handleeoback(); }
        if ((strcmp(command,"TOPIC")==0) || (strcmp(command,"T")==0)) { handletopic(); }
      }
    }
  } while (lastline[0]!='\0');
  fclose(sockin);
  fclose(sockout);
//  dumpuserlist();
  sprintf(logline,"Last line received was: %s",prevline); putlog();
  sprintf(logline,"Closing SQL-Connection..."); putlog();
  mysql_close(&sqlcon);
  sprintf(logline,"Cleaning up..."); putlog();
  while (modulelist.cursi>0) { removemodule(((loadedmod *)(modulelist.content))[0].name); }
  array_free(&modulelist);
  array_free(&commandlist);
  for (iii=0;iii<SIZEOFNL;iii++) { array_free(&nls[iii]); }
  for (iii=0;iii<SIZEOFCL;iii++) {
    channel *a, *b;
    a=cls[iii];
    while (a!=NULL) {
      b=a;
      a=(void *)a->next;
      array_free(&(b->users));
      free(b);
    }
  }
  for (iii=0;iii<SIZEOFUL;iii++) {
    userdata *a, *b;
    a=uls[iii];
    while (a!=NULL) {
      b=a;
      a=(void *)a->next;
      free(b);
    }
  }
  for (iii=0;iii<256;iii++) { array_free(&(mainrnl[iii])); }
  for (iii=0;iii<256;iii++) { snlfree(&(mainsnl[iii])); }
  free(nicktomsg);
  sprintf(logline,"Done."); putlog();
  return 0;
}
